module CONTROL (REQUEST, EQUAL, RESET, CLK, DBVALUE, BUSY, AUTHORIZE) ;

input REQUEST ;
input EQUAL ;
input RESET ;
input CLK ;
input DBVALUE ;
output BUSY ;
output AUTHORIZE ;

// add your declarations here

parameter WAIT_ID   = 0;
parameter CHECK_ID  = 1;
parameter AUTH      = 2;
parameter CLEAR_REG = 3;

reg BUSY;
reg AUTHORIZE;

reg [1:0] STATE;
reg [1:0] NEXT_STATE;

// add your code here

always @(posedge CLK) begin
	if(RESET) begin
		STATE[1:0] <= WAIT_ID;
	end else begin
		STATE[1:0] <= NEXT_STATE[1:0];
	end
end

always @(REQUEST or EQUAL or DBVALUE or STATE) begin
	case(STATE)
		WAIT_ID: begin
			if(REQUEST) begin
				NEXT_STATE[1:0] <= CHECK_ID;
			end else begin
				NEXT_STATE[1:0] <= WAIT_ID;
			end
			
			BUSY      = 0;
			AUTHORIZE = 0;
		end
		
		CHECK_ID: begin
			if(DBVALUE) begin
				NEXT_STATE[1:0] <= AUTH;
			end else begin
				NEXT_STATE[1:0] <= CLEAR_REG;
			end
			
			BUSY      = 1;
			AUTHORIZE = 0;
		end
		
		AUTH: begin
			if(EQUAL) begin
				NEXT_STATE[1:0] <= CLEAR_REG;
			end else begin
				NEXT_STATE[1:0] <= AUTH;
			end
			
			BUSY      = 1;
			AUTHORIZE = 1;
		end
		
		CLEAR_REG: begin
			if(REQUEST) begin
				NEXT_STATE[1:0] <= CLEAR_REG;
			end else begin
				NEXT_STATE[1:0] <= WAIT_ID;
			end
			
			BUSY      = 0;
			AUTHORIZE = 0;
		end
		
		default: begin
			NEXT_STATE[1:0] <= WAIT_ID;
			
			BUSY      = 0;
			AUTHORIZE = 0;
		end
	endcase
end

endmodule 
