module DOOR_CONTROL (RESET, ENABLE, EQ_HI, EQ_LO, CLK, OUT, CLR_LO, CLR_HI, OPEN) ;

input RESET ;
input ENABLE ;
input EQ_HI ;
input EQ_LO ;
input CLK ;
output OUT ;
output CLR_LO ;
output CLR_HI ;
output OPEN ;

// add your declarations here

parameter INIT   = 0;
parameter HI_ONE = 1;
parameter LO     = 2;
parameter HI_TWO = 3;

reg OUT;
reg CLR_LO;
reg CLR_HI;
reg OPEN;

reg [1:0] STATE;
reg [1:0] NEXT_STATE;

// add your code here

always @(posedge CLK) begin
	if(RESET) begin
		STATE[1:0] <= INIT;
	end else begin
		STATE[1:0] <= NEXT_STATE[1:0];
	end
end

always @(ENABLE or EQ_LO or EQ_HI or STATE) begin
	case(STATE)
		INIT: begin
			if(ENABLE) begin
				NEXT_STATE[1:0] <= HI_ONE;
			end else begin
				NEXT_STATE[1:0] <= INIT;
			end
			
			OUT    <= 0;
			CLR_LO <= 1;
			CLR_HI <= 1;
			OPEN   <= 0;
		end
		
		HI_ONE: begin
			if(EQ_HI) begin
				NEXT_STATE[1:0] <= LO;
			end else begin
				NEXT_STATE[1:0] <= HI_ONE;
			end
			
			OUT    <= 1;
			CLR_LO <= 1;
			CLR_HI <= 0;
			OPEN   <= 1;
		end
		
		LO: begin
			if(EQ_LO) begin
				NEXT_STATE[1:0] <= HI_TWO;
			end else begin
				NEXT_STATE[1:0] <= LO;
			end
			
			OUT    <= 0;
			CLR_LO <= 0;
			CLR_HI <= 1;
			OPEN   <= 1;
		end
		
		HI_TWO: begin
			if(EQ_HI) begin
				NEXT_STATE[1:0] <= INIT;
			end else begin
				NEXT_STATE[1:0] <= HI_TWO;
			end
			
			OUT    <= 1;
			CLR_LO <= 1;
			CLR_HI <= 0;
			OPEN   <= 1;
		end
		
		default: begin
			NEXT_STATE[1:0] <= INIT;
			
			OUT    <= 0;
			CLR_LO <= 1;
			CLR_HI <= 1;
			OPEN   <= 0;
		end
	endcase
end

endmodule 
