module IDChecker (BADGEID, REQUEST, RESET, CLK, BUSY, AUTH) ;

input [7:0] BADGEID ;
input REQUEST ;
input RESET ;
input CLK ;
output BUSY ;
output AUTH ;

////////// add your declarations here

// Finite State Machine
parameter ZERO = 0;	// Not-busy state
parameter ONE  = 1;	// Busy state
parameter TWO  = 2;	// Authorized state

// Authorized IDs
parameter NUM_ID = 2;
parameter ID_0   = 8'b0000_0000;
parameter ID_1   = 8'b0000_0001;

// One-second interval
parameter ONE_SECOND = 25000000;

// Badge ID
reg [7:0] ID;

// Finite State Machine
reg [1:0] STATE;
reg [1:0] NEXT_STATE;

// Output signals
reg BUSY;
reg AUTH;

// Done checking the ID
reg DONE;

// For loop index
integer i;

////////// add your code here

// Register
always @(posedge CLK) begin
	if(RESET) begin
		STATE = ZERO;
		BUSY  = 1'b0;
		AUTH  = 1'b0;
	end else begin
		STATE = NEXT_STATE;
	end
end

always @(REQUEST or STATE) begin
	case(STATE)
		// Not-busy state
		ZERO: begin
//			counter = counter + 1;
			
//			for(i = 0; i < ONE_SECOND; i = i + 1) begin
//				;
//			end
			
//			BUSY = 1'b0;
//			AUTH = 1'b0;
			
//			NEXT_STATE = ONE;
			
//			if(REQUEST) begin
//				NEXT_STATE = ONE;
				
//				ID[7:0] = BADGEID[7:0];
//			end else begin
//				NEXT_STATE = ZERO;
//			end
		end
		
		// Busy state
		ONE: begin
			BUSY = 1'b1;
			AUTH = 1'b1;
			
//			BUSY = 1'b1;
//			AUTH = 1'b0;
		end
		
		// Authorized state
//		TWO: begin
//			BUSY = 1'b0;
//			AUTH = 1'b1;
//		end
		
		default: begin
			NEXT_STATE = ZERO;
			BUSY       = 1'b0;
			AUTH       = 1'b0;
		end
	endcase
end

endmodule 
